﻿using BeSafePlus.ViewModels;
using Microsoft.Maui.Controls;

namespace BeSafePlus
{
    public partial class App : Application
    {
        private readonly SettingsViewModel _settingsViewModel;
        public App(SettingsViewModel settingsViewModel)
        {
            InitializeComponent();

            _settingsViewModel = settingsViewModel;

            MainPage = new AppShell(_settingsViewModel);

            var darkTheme = Preferences.Default.Get("DarkMode", true);
            if(darkTheme)
            {
                UserAppTheme = AppTheme.Dark;
            }
            else
            {
                UserAppTheme = AppTheme.Light;
            }
        }
    }
}