﻿using BeSafePlus.Models;
using BeSafePlus.Sensors;
using System;
using System.Threading.Tasks;

namespace BeSafePlus.Database
{
    public interface ILocalDatabase
    {
        Task SetUserId();
        Task UpdateUser(User user);
        Task<User?> GetUser();
        Task UpdateUserName(string newName);
        Task UpdateUserGender(string newGender);
        Task UpdateUserAge(int newAge);
        Task UpdateUserHeight(int newHeight);
        Task UpdateUserWeight(string newWeight);
        Task<int> CreateOrUpdateStepCount(int stepCount);
        Task<int> UpdateStepGoal(int stepGoal);
        Task<int> CreateStepAlert(StepAlert stepalert);
        Task<int> DeleteUser(User user);
        Task<StepCount?> GetStepCountByDate(DateTime date);
        Task<StepAlert?> GetStepAlertByDate(DateTime date);
        Task SaveActivityLevel(SensorEventHandler.UserActivityState userActivityState, DateTime timeOfActivityChange);
        Task FlushActivityLevel();
        Task<string> GetName();
        Task<string> GetGender();
        Task<int> GetAge();
        Task<int> GetHeight();
        Task<string> GetWeight();
        Task<List<ActivityLevel>> GetTodaysActivity();
        Task<RedCapToken?> GetRedCapToken();
        Task SaveRedCapToken(string redCapToken);
    }
}