using BeSafePlus.Database;
using ZXing.Net.Maui;

namespace BeSafePlus.Views;
public partial class QrScannerPage : ContentPage
{
    private readonly ILocalDatabase _localDatabase;
	public QrScannerPage(ILocalDatabase localDatabase)
	{
		InitializeComponent();

        _localDatabase = localDatabase;
        cameraView.Options = new BarcodeReaderOptions
        {
            Formats = BarcodeFormat.QrCode,
            AutoRotate = true,
            Multiple = false,
            TryHarder = true,
            TryInverted = true,
        };
	}
    private void CameraBarcodeReaderView_BarcodesDetected(object sender, BarcodeDetectionEventArgs e)
    {
        MainThread.BeginInvokeOnMainThread(async () =>
        {
            var scannedToken = e.Results.FirstOrDefault()?.Value;

            if (!string.IsNullOrEmpty(scannedToken))
            {
                cameraView.IsDetecting = false;
                if (TokenValidFormat(scannedToken))
                {
                    await _localDatabase.SaveRedCapToken(scannedToken);

                    await DisplayAlert("QR koden blev scannet og godkendt", "Klik ok for at forstte", "OK");

                    await Shell.Current.GoToAsync("..");
                }

                else
                {
                    var tryAgain = await DisplayAlert("Den scannede token er ugyldig", scannedToken, "Prv igen", "Annuller");
                    if (tryAgain)
                    { 
                        cameraView.IsDetecting = true;
                    }
                    else
                    {
                        await Shell.Current.GoToAsync("..");
                    }
                }
            }
        });
    }
    private bool TokenValidFormat(string token)
    {
        // do some stuff
        if(token.Contains("redcap"))
            return true;

        return false;
    }
    void SwitchCameraButton_Clicked(object sender, EventArgs e)
    {
        cameraView.CameraLocation = cameraView.CameraLocation == CameraLocation.Rear ? CameraLocation.Front : CameraLocation.Rear;
    }
    void TorchButton_Clicked(object sender, EventArgs e)
    {
        cameraView.IsTorchOn = !cameraView.IsTorchOn;
    }
}